-- automatically generated by BNF Converter
module Main where


import IO ( stdin, hGetContents )
import System ( getArgs, getProgName )

import Lexsyntax
import Parsyntax
import Skelsyntax
import Printsyntax
import Abssyntax

import Typecheck
import Control.Monad.State
import Data.Map as Map hiding (showTree)

import ErrM

type ParseFun a = [Token] -> Err a

myLLexer = myLexer

type Verbosity = Int

putStrV :: Verbosity -> String -> IO ()
putStrV v s = if v > 1 then putStrLn s else return ()

runFile :: Verbosity -> ParseFun Stms -> FilePath -> IO ()
runFile v p f = putStrLn f >> readFile f >>= run v p

run :: Verbosity -> ParseFun Stms -> String -> IO ()
run v p s = let ts = myLLexer s in case p ts of
	Bad s    -> do
		putStrLn "\nParse              Failed...\n"
		putStrV v "Tokens:"
		putStrV v $ show ts
		putStrLn s
	Ok (Program s) -> do
		putStrLn "\nParse Successful!"
		showTree v (Program s)
		runStateT (mapM typeCheckStm s) [empty]
		print "The program is type-correct!!"
		return ()

showTree :: (Show a, Print a) => Int -> a -> IO ()
showTree v tree
 = do
      putStrV v $ "\n[Abstract Syntax]\n\n" ++ show tree
      putStrV v $ "\n[Linearized tree]\n\n" ++ printTree tree

main :: IO ()
main = do args <- getArgs
          case args of
            [] -> hGetContents stdin >>= run 2 pStms
            "-s":fs -> mapM_ (runFile 0 pStms) fs
            fs -> mapM_ (runFile 2 pStms) fs





